# Sample "Distributor" Script for pxWorks
# Author: cloudcell

# Starting Up ------------------------------------------------------------------
# set working directory to the directory of the script:
# setwd(dirname(parent.frame(2)$ofile))
message(getwd()) # shows current working directory
# stop()
# the environment creates this file ("paths.meta")
paths_to_get_input_data <- read.delim(file="paths.meta", header = F, as.is = T)
paths_to_make_output_data <- read.delim(file="sockets_o.meta", header = F, sep=" ", as.is = T)
paths_to_make_output_data <- paths_to_make_output_data[-nrow(paths_to_make_output_data),]
output_data_sockets_nbr <- length(paths_to_make_output_data)
output_data_fn <- as.vector(paths_to_make_output_data)
# ------------------------------------------------------------------------------

# count the number of _output_data_ files that exist in the folder
# and compare against the number of output sockets
# if some of the sockets are not ready to fire the data, take
# the data file from the source and request for more to be ready
# otherwise just make a pause and quit (as this block will be fired again
# after it exits the code, hence pause is necessary)
if(sum(file.exists(output_data_fn))<output_data_sockets_nbr) {
    for(fn in output_data_fn){
        if(!file.exists(fn)){
            # snatch the file from source
            file.rename(paths_to_get_input_data$V1[1],fn)
            
            # request a new chunk of data
            signal_done <- "NEXT"
            write.csv(signal_done,"tmp.done")
            file.rename(from="tmp.done",to="done") # atomic operation
            
            break
        }
    }
} else {
    Sys.sleep(1)
    
    # request a new chunk of data
    signal_done <- "REFEED"
    write.csv(signal_done,"tmp.done")
    file.rename(from="tmp.done",to="done") # atomic operation
}



# Saving Work ------------------------------------------------------------------
# The write must be an atomic operation to prevent conflicts over file
# when the file is being written to / flushed from memory to drive

message("Done.")
# ------------------------------------------------------------------------------
